(* $Id: define.ml,v 1.2 1998/02/16 07:07:03 garrigue Exp $ *)

#open"common";;
#open"types";;

(* types *)

let constructors = (hashtbl__new 149 : (string, constr_info) hashtbl__t) ;;

let labels = (hashtbl__new 149 : (string, label_info) hashtbl__t) ;;

let types = (hashtbl__new 149 : (string, type_info) hashtbl__t) ;;

let types_map = ref (map__empty compare_id : (ident, type_info) map__t) ;;

let make_ti id params kind =
  { ti_params = params ;
    ti_res = Tconstr (id, map (fun tv -> Tvar tv) params) ;
    ti_kind = kind }
;;

let add_type name info =
  hashtbl__add types name info;
  begin match info.ti_res with
    Tconstr (id, _) -> types_map := map__add id info !types_map
  |	_ -> failwith "define__add_info"
  end;
  match info.ti_kind with
    Kabbrev _ -> ()
  | Kvariant l ->
      let _ =
	it_list
          (fun n (name,ty_args) ->
	    hashtbl__add constructors name
	      { ci_params = info.ti_params ;
		ci_args = ty_args ;
		ci_res = info.ti_res ;
		ci_size = list_length ty_args ;
		ci_tag = n };
	    n + 1)
          0 l
      in ()
  | Krecord l ->
      let total = list_length l in
      let _ =
	it_list
          (fun n (name, ty_arg, access) ->
	    hashtbl__add labels name
	      { li_params = info.ti_params ;
		li_arg = ty_arg ;
		li_res = info.ti_res ;
		li_access = access ;
		li_total = total ;
		li_index = n };
	    n + 1)
          0 l
      in ()
  | Kbasic -> ()
;;

(* types *)

let values =
  ref (map__empty compare_strings : (string, value_info) map__t) ;;

let global_idents = ref [] ;;

let global_env =
  ref (map__empty compare_id : (ident, obj__obj ref) map__t);;

let add_value id obj info =
  values := map__add id.name info !values;
  global_env := map__add id (ref obj) !global_env;
  global_idents := (id.name, id) :: !global_idents
;;
